wayland::data_source_t(3)

NAME
wayland::data_source_t - offer to transfer data

SYNOPSIS

#include <wayland-client-protocol.hpp>

Inherits wayland::proxy_t.

  Public Types

enum class wrapper_type { standard, display, foreign, proxy_wrapper }

  Public Member Functions

void offer (std::string const &mime_type)
add an offered mime type
void set_actions (data_device_manager_dnd_action const &dnd_actions)
set the available drag-and-drop actions
bool can_set_actions () const
Check whether the set_actions function is available with the currently bound version of the protocol.
std::function< void(std::string)> & on_target ()
a target accepts an offered mime type
std::function< void(std::string, int)> & on_send ()
send the data
std::function< void()> & on_cancelled ()
selection was cancelled
std::function< void()> & on_dnd_drop_performed ()
the drag-and-drop operation physically finished
std::function< void()> & on_dnd_finished ()
the drag-and-drop operation concluded
std::function< void(data_device_manager_dnd_action)> & on_action ()
notify the selected action
uint32_t get_id () const
Get the id of a proxy object.
std::string get_class () const
Get the interface name (class) of a proxy object.
uint32_t get_version () const
Get the protocol object version of a proxy object.
wrapper_type get_wrapper_type () const
Get the type of a proxy object.
void set_queue (event_queue_t queue)
Assign a proxy to an event queue.
wl_proxy * c_ptr () const
Get a pointer to the underlying C struct.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
operator bool () const
Check whether this wrapper actually wraps an object.
bool operator== (const proxy_t &right) const
Check whether two wrappers refer to the same object.
bool operator!= (const proxy_t &right) const
Check whether two wrappers refer to different objects.
void proxy_release ()
Release the wrapped object (if any), making this an empty wrapper.

  Static Public Attributes

static constexpr std::uint32_t offer_since_version = 1
Minimum protocol version required for the offer function.
static constexpr std::uint32_t set_actions_since_version = 3
Minimum protocol version required for the set_actions function.

Detailed Description

offer to transfer data

The wl_data_source object is the source side of a wl_data_offer. It is created by the source client in a data transfer and provides a way to describe the offered data and a way to respond to requests to transfer the data.

Definition at line 1002 of file wayland-client-protocol.hpp.

Member Enumeration Documentation

  enum class wayland::proxy_t::wrapper_type [strong], [inherited]
Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator

standard
    C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.

display
    C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign
    C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper
    C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 117 of file wayland-client.hpp.

Member Function Documentation

  wl_proxy * wayland::proxy_t::c_ptr () const [inherited]

Get a pointer to the underlying C struct.

Returns
    The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

  bool data_source_t::can_set_actions () const

Check whether the set_actions function is available with the currently bound version of the protocol.

Definition at line 2158 of file wayland-client-protocol.cpp.

  std::string wayland::proxy_t::get_class () const [inherited]

Get the interface name (class) of a proxy object.

Returns
    The interface name of the object associated with the proxy

  uint32_t wayland::proxy_t::get_id () const [inherited]

Get the id of a proxy object.

Returns
    The id the object associated with the proxy

  uint32_t wayland::proxy_t::get_version () const [inherited]

Get the protocol object version of a proxy object. Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
    The protocol object version of the proxy or 0

  wrapper_type wayland::proxy_t::get_wrapper_type () const [inline], [inherited]

Get the type of a proxy object.

Definition at line 303 of file wayland-client.hpp.

  void data_source_t::offer (std::string const & mime_type)

add an offered mime type

Parameters
    mime_type mime type offered by the data source

This request adds a mime type to the set of mime types advertised to targets. Can be called several times to offer multiple types.

Definition at line 2147 of file wayland-client-protocol.cpp.

  std::function< void(data_device_manager_dnd_action)> & data_source_t::on_action ()

notify the selected action

Parameters
    dnd_action action selected by the compositor

This event indicates the action selected by the compositor after matching the source/destination side actions. Only one action (or none) will be offered here.

This event can be emitted multiple times during the drag-and-drop operation, mainly in response to destination side changes through wl_data_offer.set_actions, and as the data device enters/leaves surfaces.

It is only possible to receive this event after wl_data_source.dnd_drop_performed if the drag-and-drop operation ended in an "ask" action, in which case the final wl_data_source.action event will happen immediately before wl_data_source.dnd_finished.

Compositors may also change the selected action on the fly, mainly in response to keyboard modifier changes during the drag-and-drop operation.

The most recent action received is always the valid one. The chosen action may change alongside negotiation (e.g. an "ask" action can turn into a "move" operation), so the effects of the final action must always be applied in wl_data_offer.dnd_finished.

Clients can trigger cursor surface changes from this point, so they reflect the current action.

Definition at line 2189 of file wayland-client-protocol.cpp.

  std::function< void()> & data_source_t::on_cancelled ()

selection was cancelled This data source is no longer valid. There are several reasons why this could happen:

•   The data source has been replaced by another data source.

•   The drag-and-drop operation was performed, but the drop destination did not accept any of the mime types offered through wl_data_source.target.

•   The drag-and-drop operation was performed, but the drop destination did not select any of the actions present in the mask offered through wl_data_source.action.

•   The drag-and-drop operation was performed but didn't happen over a surface.

•   The compositor cancelled the drag-and-drop operation (e.g. compositor dependent timeouts to avoid stale drag-and-drop transfers).

The client should clean up and destroy this data source.

For objects of version 2 or older, wl_data_source.cancelled will only be emitted if the data source was replaced by another data source.

Definition at line 2174 of file wayland-client-protocol.cpp.

  std::function< void()> & data_source_t::on_dnd_drop_performed ()

the drag-and-drop operation physically finished The user performed the drop action. This event does not indicate acceptance, wl_data_source.cancelled may still be emitted afterwards if the drop destination does not accept any mime type.

However, this event might however not be received if the compositor cancelled the drag-and-drop operation before this event could happen.

Note that the data_source may still be used in the future and should not be destroyed here.

Definition at line 2179 of file wayland-client-protocol.cpp.

  std::function< void()> & data_source_t::on_dnd_finished ()

the drag-and-drop operation concluded The drop destination finished interoperating with this data source, so the client is now free to destroy this data source and free all associated data.

If the action used to perform the operation was "move", the source can now delete the transferred data.

Definition at line 2184 of file wayland-client-protocol.cpp.

  std::function< void(std::string, int)> & data_source_t::on_send ()

send the data

Parameters
    mime_type mime type for the data
    fd file descriptor for the data

Request for data from the client. Send the data as the specified mime type over the passed file descriptor, then close it.

Definition at line 2169 of file wayland-client-protocol.cpp.

  std::function< void(std::string)> & data_source_t::on_target ()

a target accepts an offered mime type

Parameters
    mime_type mime type accepted by the target

Sent when a target accepts pointer_focus or motion events. If a target does not accept any of the offered types, type is NULL.

Used for feedback during drag-and-drop.

Definition at line 2164 of file wayland-client-protocol.cpp.

  wayland::proxy_t::operator bool () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  bool wayland::proxy_t::operator!= (const proxy_t & right) const [inherited]

Check whether two wrappers refer to different objects.

  bool wayland::proxy_t::operator== (const proxy_t & right) const [inherited]

Check whether two wrappers refer to the same object.

  bool wayland::proxy_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  void wayland::proxy_t::proxy_release () [inherited]

Release the wrapped object (if any), making this an empty wrapper. Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
foreign_display.cpp.

  void data_source_t::set_actions (data_device_manager_dnd_action const & dnd_actions)

set the available drag-and-drop actions

Parameters
    dnd_actions actions supported by the data source

Sets the actions that the source side client supports for this operation. This request may trigger wl_data_source.action and wl_data_offer.action events if the compositor needs to change the selected action.

The dnd_actions argument must contain only values expressed in the wl_data_device_manager.dnd_actions enum, otherwise it will result in a protocol error.

This request must be made once only, and can only be made on sources used in drag-and-drop, so it must be performed before wl_data_device.start_drag. Attempting to use the source other than for drag-and-drop will raise a protocol error.

Definition at line 2153 of file wayland-client-protocol.cpp.

  void wayland::proxy_t::set_queue (event_queue_t queue) [inherited]

Assign a proxy to an event queue.

Parameters
    queue The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
proxy_wrapper.cpp.

Member Data Documentation

  std::uint32_t wayland::data_source_t::offer_since_version = 1 [static], [constexpr]

Minimum protocol version required for the offer function.

Definition at line 1042 of file wayland-client-protocol.hpp.

  std::uint32_t wayland::data_source_t::set_actions_since_version = 3 [static], [constexpr]

Minimum protocol version required for the set_actions function.

Definition at line 1066 of file wayland-client-protocol.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.